package com.huimv.eartag2.manage2.service.impl;

import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import com.huimv.eartag2.manage2.pojo.EartagData;
import com.huimv.eartag2.manage2.pojo.EartagData2;
import com.huimv.eartag2.manage2.mapper.EartagData2Mapper;
import com.huimv.eartag2.manage2.service.IEartagData2Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2022-07-29
 */
@Service
public class EartagData2ServiceImpl extends ServiceImpl<EartagData2Mapper, EartagData2> implements IEartagData2Service {

    @Resource
    private EartagData2Mapper eartagData2Mapper;

    @Override
    public List<EartagData2> getEartagData(String earmark) throws ParseException {
        QueryWrapper<EartagData2> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("earmark", earmark);
        List<EartagData2> eartagData2s = eartagData2Mapper.selectList(queryWrapper);

        //查询出来五分钟之内的数据;

        Calendar calendar = Calendar.getInstance();
        //1-当前时间
        Long currentTimestamps = System.currentTimeMillis();

        //存五秒内的数据
        ArrayList<EartagData2> eartagData2s1 = new ArrayList<>();
        if (null != eartagData2s && eartagData2s.size() > 0) {
            for (EartagData2 eartagData2 : eartagData2s) {
                String addTime = eartagData2.getAddTime() + "";
                calendar.setTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").parse(addTime));
                long timeInMillis = calendar.getTimeInMillis();
                if (currentTimestamps - timeInMillis <= 5000) {
                    eartagData2s1.add(eartagData2);
                }
            }
        }
        return eartagData2s1;
    }

    @Override
    public Result getEnvByTime(Map<String, String> map) {
        String earmark = map.get("earmark");
        String startDate = map.get("startDate");
        String endDate = map.get("endDate");
        Date now = new Date();

        if (StringUtils.isBlank(earmark)){
            return new Result(10001,"请选择耳标",false);
        }
        QueryWrapper<EartagData2> wrapper = new QueryWrapper<>();
        wrapper.eq("earmark",earmark);
        if (StringUtils.isBlank(startDate)){
            wrapper.ge("add_time", DateUtil.beginOfDay(now));
        }else {
            wrapper.between("add_time",startDate,endDate);
        }

        wrapper.orderByAsc("add_time");
        List<EartagData2> list = this.list(wrapper);

        return new Result(ResultCode.SUCCESS,list);
    }
}
