package com.huimv.eartag2.manage2.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import com.huimv.eartag2.manage2.pojo.EartagEartagRegister;
import com.huimv.eartag2.manage2.pojo.EartagEartagRegister2;
import com.huimv.eartag2.manage2.mapper.EartagEartagRegister2Mapper;
import com.huimv.eartag2.manage2.service.IEartagEartagRegister2Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2022-08-04
 */
@Service
public class EartagEartagRegister2ServiceImpl extends ServiceImpl<EartagEartagRegister2Mapper, EartagEartagRegister2> implements IEartagEartagRegister2Service {

    @Override
    public Result listFarmUnitEartagData(Map<String, String> params) {
        String pageSize = params.get("pageSize");
        String pageNo = params.get("pageNo");
        String unitId = params.get("unitId");
        String deviceCode = params.get("deviceCode");
        String farmId = params.get("farmId");
        String earmark = params.get("earmark");
        String liveStatus = params.get("liveStatus");
        if (StringUtils.isBlank(pageNo)){
            pageNo="1";
        }
        if (StringUtils.isBlank(pageSize)){
            pageSize="20";
        }
        Float maxEarTemp = 0F;
        Float minEarTemp = 100F;
        QueryWrapper<EartagEartagRegister2> wrapper = new QueryWrapper<>();
        //设备
        wrapper.like(StringUtils.isNotBlank(deviceCode),"belong_device",deviceCode);
        wrapper.eq("farm_id",farmId);
        wrapper.eq(StringUtils.isNotBlank(unitId),"unit_id",unitId);
        wrapper.like(StringUtils.isNotBlank(earmark),"earmark",earmark);
        wrapper.eq(StringUtils.isNotBlank(liveStatus),"live_status",liveStatus);
        wrapper.orderByDesc("ask_time");
        //吴老师要求，屏蔽耳标
//        wrapper.ne("earmark","133308351200023");
        Page<EartagEartagRegister2> page = this.page(new Page<>(Long.parseLong(pageNo), Long.parseLong(pageSize)), wrapper);
        if (page.getRecords().size() == 0){
            minEarTemp = 0F;
        }
        Map map = new HashMap();
        long allCount = this.count(wrapper);

        //在线
        wrapper.eq("live_status", 1);
        long onCount = this.count(wrapper);
        List<EartagEartagRegister2> list = this.list(wrapper);
        for (EartagEartagRegister2 record : list) {
            Float earTemp1 = record.getEarTemp1();
            //吴老师要求，屏蔽耳标
            if (earTemp1 <41.9){
                maxEarTemp = Math.max(earTemp1,maxEarTemp);
            }

            minEarTemp = Math.min(earTemp1,minEarTemp);
        }


        map.put("countOff",allCount-onCount);
        map.put("countOn",onCount);
        map.put("countAll",allCount);
        map.put("maxEarTemp",maxEarTemp);
        map.put("minEarTemp",minEarTemp);
        map.put("page",page);

        return new Result(ResultCode.SUCCESS,map);

    }
}
